;
;	DF.ahk - ver 0.01 (2007/10/11)
;		Helper script for invoking DF with custom configuration
;		Written by Yak!
;
;	$URL: https://yak.myhome.cx/repos/source/myusr/trunk/DF.ahk $
;  $Date: 2007-10-11 23:06:16 +0900 (Thu, 11 Oct 2007) $
;	$Rev: 460 $
;

; Constant
OPTIONKEY=Software\Sankakutou Lab\DF\Option
DFKEY=Software\Sankakutou Lab\DF

; Extracted from AHK help
RegKeyType(RootKey, SubKey, ValueName)	; This function returns the type of the specified value.
{
	Loop, %RootKey%, %SubKey%
		if (A_LoopRegName = ValueName)
			return A_LoopRegType
	return "Error"
}

; Get DF.exe path
GetDFPath()
{
	ini_path=%A_ScriptDir%\DF.ahk.ini
	Loop
	{
		IfExist, %ini_path%
		{
			IniRead, df_path, %ini_path%, Settings, DFPath
			IfExist, %df_path%
			{
				FileGetAttrib, attr, %df_path%
				IfNotInString, attr, D
					return %df_path%
			}
		}
		FileSelectFile, df_path, 3, %df_path%, Select DF.exe, Executable (*.exe)
		IniWrite, %df_path%, %ini_path%, Settings, DFPath
	}
}

; Copy registry key one level
RegKeyCopy(RKey1, SubKey1, RKey2, SubKey2)
{
	Loop, %RKey1%, %SubKey1%
	{
		RegRead, Value
		RegWrite, %A_LoopRegType%, %RKey2%, %SubKey2%, %A_LoopRegName%, %Value%
	}
}

; Not used
GetOptionSuffixes(VarName)
{
	global
	local num=0
	Loop, HKCU, %DFKEY%, 2
	{
		if(SubStr(A_LoopRegName, 1, StrLen("Option.")) = "Option.")
		{
			num:=num+1
			StringTrimLeft, %VarName%%num%, A_LoopRegName, % StrLen("Option.")
		}
	}
	return num
}

; Case-insensitive Search option key name
FindOption(Key)
{
	global
	Loop, HKCU, %DFKEY%, 2
	{
		if(SubStr(A_LoopRegName, 1, StrLen("Option.")) = "Option.")
		{
			StringTrimLeft, regkey, A_LoopRegName, % StrLen("Option.")
			If(regkey=Key)
				return regkey
		}
	}
	return
}

DFPATH:=GetDFPath()

if 0=0
{
; No argument
	InputBox, name, Save current configuration as, Input configuration name, , 300, 120
	if ErrorLevel
		Exit
	RegKeyCopy("HKCU", OPTIONKEY, "HKCU", OPTIONKEY . "." . name)
} else {
; With argument(s)

; Parse arguments
	setnum=0
	Loop, %0%
	{
		If(SubStr(%A_Index%, 1, 1) = "/")
		{
			pos:=InStr(%A_Index%, ":")
			optname:=SubStr(%A_Index%, 2, pos-2)
			optval:=SubStr(%A_Index%, pos+1, StrLen(%A_Index%) - pos)
			if optname = config
			{
				config=%optval%
			} else if optname = set
			{
				pos:=InStr(optval, "=")
				setnum:=setnum+1
				name%setnum%:=SubStr(optval, 1, pos-1)
				value%setnum%:=SubStr(optval, pos+1, StrLen(optval)-pos)
			}
		} else {
			args:=args . " """ . %A_Index% . """"
		}
	}

; Copy configuration if necessary
	config:=FindOption(config)
	if config
	{
		RegKeyCopy("HKCU", OPTIONKEY . "." . config, "HKCU", OPTIONKEY)
	}

; Overwrite specific registry values
	if setnum > 0
	{
		Loop, %setnum%
		{
			name:=name%A_Index%
			value:=value%A_Index%
			type:=RegKeyType("HKCU", OPTIONKEY, name)
			RegWrite, %type%, HKCU, %OPTIONKEY%, %name%, %value%
		}
	}

; Run DF
	Run, %DFPATH% %args%

}
